package mahjong;

public class AllGreenChecker extends GroupChecker
{
    public boolean checkRun (Hand hand, int[] tilesToCheck)
    {
	for (int i = 0; i < 3; i++)
	{
	    if (!isGreen((Tile)hand.getClosedTiles().get(tilesToCheck[i])))
		return (false);
	}
	
	return (true);
    }

    public boolean checkSet (Hand hand, int[] tilesToCheck)
    {
	if (isGreen((Tile)hand.getClosedTiles().get(tilesToCheck[0])))
	    return (true);
	else
	    return (false);
    }

    public boolean checkHead(Hand hand, int[] tilesToCheck)
    {
	if (isGreen((Tile)hand.getClosedTiles().get(tilesToCheck[0])))
	    return (true);
	else
	    return (false);
    }

    // new method
    public static  boolean isGreen(Tile tile)
    {
	return ( (tile.getType() == TileType.SOUZU && (tile.getOrder() == 2 ||
						       tile.getOrder() == 3 ||
						       tile.getOrder() == 4 ||
						       tile.getOrder() == 6 ||
						       tile.getOrder() == 8   ) ) ||
		 (tile.getType() == TileType.SANGENPAI && tile.getOrder() == 2) );
    }
}
