package mahjong;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class DiscardDialog extends JDialog
{
    public DiscardDialog(JFrame owner)
    {
	// create a modal JDialog
	super(owner, "Discard Dialog", true);

	// assemble the Dialog
	messageLabel.setText("O que voce deseja fazer com a pedra descartada? ");
	leftChiPanel.setLayout(new BoxLayout(leftChiPanel, BoxLayout.Y_AXIS));
	leftChiMeld.setAlignmentX(Component.CENTER_ALIGNMENT);
	leftChiButton.setAlignmentX(Component.CENTER_ALIGNMENT);
	leftChiPanel.add(leftChiMeld);
	leftChiPanel.add(Box.createRigidArea(new Dimension(0, 5)));
	leftChiPanel.add(leftChiButton);
	leftChiPanel.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED),
								  BorderFactory.createEmptyBorder(10, 10, 10, 10)));
	leftChiPanel.setBackground(new Color(0.20f, 0.70f, 0.20f));
	leftChiPanel.setAlignmentY(Component.BOTTOM_ALIGNMENT);

	centerChiPanel.setLayout(new BoxLayout(centerChiPanel, BoxLayout.Y_AXIS));
	centerChiPanel.setAlignmentX(Component.CENTER_ALIGNMENT);
	centerChiButton.setAlignmentX(Component.CENTER_ALIGNMENT);
	centerChiPanel.add(centerChiMeld);
	centerChiPanel.add(Box.createRigidArea(new Dimension(0, 5)));
	centerChiPanel.add(centerChiButton);
	centerChiPanel.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED),
								  BorderFactory.createEmptyBorder(10, 10, 10, 10)));
	centerChiPanel.setBackground(new Color(0.20f, 0.70f, 0.20f));
	centerChiPanel.setAlignmentY(Component.BOTTOM_ALIGNMENT);

	rightChiPanel.setLayout(new BoxLayout(rightChiPanel, BoxLayout.Y_AXIS));
	rightChiPanel.setAlignmentX(Component.CENTER_ALIGNMENT);
	rightChiButton.setAlignmentX(Component.CENTER_ALIGNMENT);	
	rightChiPanel.add(rightChiMeld);
	rightChiPanel.add(Box.createRigidArea(new Dimension(0, 5)));
	rightChiPanel.add(rightChiButton);
	rightChiPanel.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED),
								  BorderFactory.createEmptyBorder(10, 10, 10, 10)));
	rightChiPanel.setBackground(new Color(0.20f, 0.70f, 0.20f));
	rightChiPanel.setAlignmentY(Component.BOTTOM_ALIGNMENT);

	ponPanel.setLayout(new BoxLayout(ponPanel, BoxLayout.Y_AXIS));
	ponPanel.setAlignmentX(Component.CENTER_ALIGNMENT);
	ponButton.setAlignmentX(Component.CENTER_ALIGNMENT);
	ponPanel.add(ponMeld);
	ponPanel.add(Box.createRigidArea(new Dimension(0, 5)));
	ponPanel.add(ponButton);
	ponPanel.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED),
								  BorderFactory.createEmptyBorder(10, 10, 10, 10)));
	ponPanel.setBackground(new Color(0.20f, 0.70f, 0.20f));
	ponPanel.setAlignmentY(Component.BOTTOM_ALIGNMENT);
	
	kanPanel.setLayout(new BoxLayout(kanPanel, BoxLayout.Y_AXIS));
	kanPanel.setAlignmentX(Component.CENTER_ALIGNMENT);
	kanButton.setAlignmentX(Component.CENTER_ALIGNMENT);		   
	kanPanel.add(kanMeld);
	kanPanel.add(Box.createRigidArea(new Dimension(0, 5)));
	kanPanel.add(kanButton);
	kanPanel.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED),
								  BorderFactory.createEmptyBorder(20, 20, 20, 20)));
	kanPanel.setBackground(new Color(0.20f, 0.70f, 0.20f));
	kanPanel.setAlignmentY(Component.BOTTOM_ALIGNMENT);

	ronPanel.setLayout(new BoxLayout(ronPanel, BoxLayout.Y_AXIS));
	ronPanel.add(ronLabel);
	ronPanel.add(ronButton);
	ronPanel.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED),
							      BorderFactory.createEmptyBorder(10, 10, 10, 10)));
	ronPanel.setBackground(new Color(0.70f, 0.20f, 0.20f));
	ronPanel.setAlignmentY(Component.BOTTOM_ALIGNMENT);

	nothingPanel.setLayout(new BoxLayout(nothingPanel, BoxLayout.Y_AXIS));
	nothingPanel.add(nothingLabel);
	nothingPanel.add(nothingButton);
	nothingPanel.setAlignmentY(Component.BOTTOM_ALIGNMENT);

	JPanel auxPanel1 = new JPanel();
	auxPanel1.setLayout(new BoxLayout(auxPanel1, BoxLayout.X_AXIS));
	auxPanel1.add(Box.createRigidArea(new Dimension(5, 0)));
	auxPanel1.add(leftChiPanel);
	auxPanel1.add(Box.createRigidArea(new Dimension(5, 0)));
	auxPanel1.add(centerChiPanel);
	auxPanel1.add(Box.createRigidArea(new Dimension(5, 0)));
	auxPanel1.add(rightChiPanel);
	auxPanel1.add(Box.createRigidArea(new Dimension(5, 0)));
	auxPanel1.add(ponPanel);
	auxPanel1.add(Box.createRigidArea(new Dimension(5, 0)));
	auxPanel1.add(kanPanel);
	auxPanel1.add(Box.createRigidArea(new Dimension(5, 0)));
	auxPanel1.add(ronPanel);
	auxPanel1.add(Box.createRigidArea(new Dimension(5, 0)));
	auxPanel1.add(nothingPanel);
	auxPanel1.add(Box.createRigidArea(new Dimension(5, 0)));

	JPanel auxPanel3 = new JPanel();
	auxPanel3.setLayout(new BoxLayout(auxPanel3, BoxLayout.Y_AXIS));
	auxPanel3.add(Box.createRigidArea(new Dimension(0, 5)));
	auxPanel3.add(auxPanel1);
	auxPanel3.add(Box.createRigidArea(new Dimension(0, 5)));

	JPanel auxPanel2 = new JPanel();
	auxPanel2.add(messageLabel);
	auxPanel2.add(tileLabel);

	this.getContentPane().add(auxPanel2, BorderLayout.NORTH);
	this.getContentPane().add(auxPanel3, BorderLayout.CENTER);

	// defining the buttons actions
	final DiscardDialog thisDialog = this;
	ActionListener aListener = new ActionListener ()
	    {
		public void actionPerformed(ActionEvent e)
		{
		    JButton clickedButton = (JButton)e.getSource();
		    String buttonText = clickedButton.getText();
		    if (buttonText == "Nada") answer = Action.NONE;
		    else if (buttonText == "Chi *[][]") answer = Action.LEFT_CHI;
		    else if (buttonText == "Chi []*[]") answer = Action.CENTER_CHI;
		    else if (buttonText == "Chi [][]*") answer = Action.RIGHT_CHI;
		    else if (buttonText == "Pon") answer = Action.PON;
		    else if (buttonText == "Kan") answer = Action.OPEN_KAN;
		    else if (buttonText == "Ron") answer = Action.RON;
		    thisDialog.hide();
		}
	    };
	
	leftChiButton.addActionListener(aListener);
	centerChiButton.addActionListener(aListener);
	rightChiButton.addActionListener(aListener);
	ponButton.addActionListener(aListener);
	kanButton.addActionListener(aListener);
	ronButton.addActionListener(aListener);
	nothingButton.addActionListener(aListener);
    }

    public int show(int actionMask, Tile tile, short stolenFrom)
    {
	tileLabel.setIcon(ImageServer.getInstance().getImage(tile.getName() + "_0"));
	
	short stolenPlayer = StolenPlayer.NONE;
	switch (stolenFrom)
	{
	case Position.NORTH:
	    stolenPlayer = StolenPlayer.LEFT;
	    break;
	case Position.WEST:
	    stolenPlayer = StolenPlayer.ACROSS;
	    break;
	case Position.SOUTH:
	    stolenPlayer = StolenPlayer.RIGHT;
	    break;
	}
	
	if ((actionMask & Action.LEFT_CHI) == Action.LEFT_CHI)
	{
	    Tile tiles[] = new Tile[2];
	    tiles[0] = tile.next();
	    tiles[1] = tiles[0].next();
	    OpenMeld meld = new OpenMeld(tiles, MeldType.CHI, stolenPlayer, tile);
	    leftChiMeld.notify(meld);
	    leftChiPanel.setVisible(true);
	}
	else leftChiPanel.setVisible(false);

	if ((actionMask & Action.CENTER_CHI) == Action.CENTER_CHI)
	{
	    Tile tiles[] = new Tile[2];
	    tiles[0] = tile.previous();
	    tiles[1] = tile.next();
	    OpenMeld meld = new OpenMeld(tiles, MeldType.CHI, stolenPlayer, tile);
	    centerChiMeld.notify(meld);	    
	    centerChiPanel.setVisible(true);
	}
	else centerChiPanel.setVisible(false);

	if ((actionMask & Action.RIGHT_CHI) == Action.RIGHT_CHI)
	{
	    Tile tiles[] = new Tile[2];
	    tiles[1] = tile.previous();
	    tiles[0] = tiles[1].previous();
	    OpenMeld meld = new OpenMeld(tiles, MeldType.CHI, stolenPlayer, tile);
	    rightChiMeld.notify(meld); 
	    rightChiPanel.setVisible(true);
	}
	else rightChiPanel.setVisible(false);

	if ((actionMask & Action.PON) == Action.PON)
	{
	    Tile tiles[] = new Tile[2];
	    tiles[0] = tile;
	    tiles[1] = tile;
	    OpenMeld meld = new OpenMeld(tiles, MeldType.PON, stolenPlayer, tile);
	    ponMeld.notify(meld); 
	    ponPanel.setVisible(true);
	}
	else ponPanel.setVisible(false);

	if ((actionMask & Action.OPEN_KAN) == Action.OPEN_KAN)
	{
	    Tile tiles[] = new Tile[3];
	    tiles[0] = tile;
	    tiles[1] = tile;
	    tiles[2] = tile;
	    OpenMeld meld = new OpenMeld(tiles, MeldType.OPEN_KAN, stolenPlayer, tile);
	    kanMeld.notify(meld); 
	    kanPanel.setVisible(true);
	}
	else kanPanel.setVisible(false);

	ronPanel.setVisible((actionMask & Action.RON) == Action.RON);
	nothingPanel.setVisible((actionMask & Action.NONE) == Action.NONE);

	answer = Action.NONE;
	this.setResizable(true);
	this.pack();
	Dimension thisDimension = this.getSize();
	this.setLocation((int)(1024 - thisDimension.getWidth())/2, (int)(768 - thisDimension.getHeight())/2);
	this.setResizable(false);
	this.show();
	return (answer);
    }

    // main text
    private JLabel messageLabel = new JLabel();
    private JLabel tileLabel = new JLabel();

    // left chi
    private JButton leftChiButton = new JButton("Chi *[][]");
    private EastMeldPanel leftChiMeld = new EastMeldPanel();
    private JPanel leftChiPanel = new JPanel();

    // center chi
    private JButton centerChiButton = new JButton("Chi []*[]");
    private EastMeldPanel centerChiMeld = new EastMeldPanel();
    private JPanel centerChiPanel = new JPanel();

    // right chi
    private JButton rightChiButton = new JButton("Chi [][]*");
    private EastMeldPanel rightChiMeld = new EastMeldPanel();
    private JPanel rightChiPanel = new JPanel();

    // pon
    private JButton ponButton = new JButton("Pon");
    private EastMeldPanel ponMeld = new EastMeldPanel();
    private JPanel ponPanel = new JPanel();    

    // kan
    private JButton kanButton = new JButton("Kan");
    private EastMeldPanel kanMeld = new EastMeldPanel();
    private JPanel kanPanel = new JPanel();

    // ron
    private JButton ronButton = new JButton("Ron");
    private JLabel ronLabel = new JLabel();
    private JPanel ronPanel = new JPanel();

    // do nothig
    private JButton nothingButton = new JButton("Nada");
    private JLabel nothingLabel = new JLabel();
    private JPanel nothingPanel = new JPanel();

    // message result
    private int answer;
}
