package mahjong;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class DrawDialog extends JDialog
{
    public DrawDialog(JFrame owner)
    {
	// create a modal dialog
	super(owner, "Draw Dialog", true);

	// assemble the dialog
	messageLabel.setText("O que voce deseja fazer com o pedra comprada ?");
	lateKanPanel.setLayout(new BoxLayout(lateKanPanel, BoxLayout.Y_AXIS));
	lateKanButton.setAlignmentX(Component.CENTER_ALIGNMENT);
	lateKanMeld.setAlignmentX(Component.CENTER_ALIGNMENT);
	lateKanPanel.add(lateKanMeld);
	lateKanPanel.add(Box.createRigidArea(new Dimension(0, 5)));
	lateKanPanel.add(lateKanButton);
	lateKanPanel.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED),
								  BorderFactory.createEmptyBorder(10, 10, 10, 10)));
	lateKanPanel.setBackground(new Color(0.20f, 0.70f, 0.20f));
	lateKanPanel.setAlignmentY(Component.BOTTOM_ALIGNMENT);

	closedKanPanel.setLayout(new BoxLayout(closedKanPanel, BoxLayout.Y_AXIS));
	closedKanButton.setAlignmentX(Component.CENTER_ALIGNMENT);
	closedKanMeld.setAlignmentX(Component.CENTER_ALIGNMENT);
	closedKanPanel.add(closedKanMeld);
	closedKanPanel.add(Box.createRigidArea(new Dimension(0, 5)));
	closedKanPanel.add(closedKanButton);
	closedKanPanel.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED),
								    BorderFactory.createEmptyBorder(10, 10, 10, 10)));
	closedKanPanel.setBackground(new Color(0.20f, 0.70f, 0.20f));	
	closedKanPanel.setAlignmentY(Component.BOTTOM_ALIGNMENT);

	tsumoPanel.setLayout(new BoxLayout(tsumoPanel, BoxLayout.Y_AXIS));
	tsumoPanel.add(Box.createVerticalGlue());
	tsumoPanel.add(tsumoLabel);
	tsumoPanel.add(tsumoButton);
	tsumoPanel.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED),
								BorderFactory.createEmptyBorder(20, 20, 20 ,20)));
	tsumoPanel.setBackground(new Color(0.70f, 0.20f, 0.20f));
	tsumoPanel.setAlignmentY(Component.BOTTOM_ALIGNMENT);

	nothingPanel.setLayout(new BoxLayout(nothingPanel, BoxLayout.Y_AXIS));
	nothingPanel.add(Box.createVerticalGlue());
	nothingPanel.add(nothingLabel);
	nothingPanel.add(nothingButton);
	nothingPanel.setAlignmentY(Component.BOTTOM_ALIGNMENT);

	JPanel auxPanel1 = new JPanel();
	auxPanel1.setLayout(new BoxLayout(auxPanel1, BoxLayout.X_AXIS));
	auxPanel1.add(Box.createRigidArea(new Dimension(5, 0)));
	auxPanel1.add(lateKanPanel);
	auxPanel1.add(Box.createRigidArea(new Dimension(5, 0)));
	auxPanel1.add(closedKanPanel);
	auxPanel1.add(Box.createRigidArea(new Dimension(5, 0)));
	auxPanel1.add(tsumoPanel);
	auxPanel1.add(Box.createRigidArea(new Dimension(5, 0)));
	auxPanel1.add(nothingPanel);
	auxPanel1.add(Box.createRigidArea(new Dimension(5, 0)));
	
	JPanel auxPanel3 = new JPanel();
	auxPanel3.setLayout(new BoxLayout(auxPanel3, BoxLayout.Y_AXIS));
	auxPanel3.add(Box.createRigidArea(new Dimension(0, 5)));
	auxPanel3.add(auxPanel1);
	auxPanel3.add(Box.createRigidArea(new Dimension(0, 5)));

	JPanel auxPanel2 = new JPanel();
	auxPanel2.add(messageLabel);
	auxPanel2.add(tileLabel);

	this.getContentPane().add(auxPanel2, BorderLayout.NORTH);
	this.getContentPane().add(auxPanel3, BorderLayout.CENTER);

	// defining the buttons actions
	final DrawDialog thisDialog = this;
	ActionListener aListener = new ActionListener ()
	    {
		public void actionPerformed(ActionEvent e)
		{
		    JButton clickedButton = (JButton)e.getSource();
		    String buttonText = clickedButton.getText();
		    if (buttonText == "Nada") answer = Action.NONE;
		    else if (buttonText == "Pon >> Kan") answer = Action.LATE_KAN;
		    else if (buttonText == "Kan") answer = Action.CLOSED_KAN;
		    else if (buttonText == "Tsumo") answer = Action.TSUMO;
		    thisDialog.hide();
		}
	    };

	lateKanButton.addActionListener(aListener);
	closedKanButton.addActionListener(aListener);
	tsumoButton.addActionListener(aListener);
	nothingButton.addActionListener(aListener);
    }

    public int show(int actionMask, Tile tile, short stolenFrom)
    {
	tileLabel.setIcon(ImageServer.getInstance().getImage(tile.getName() + "_0"));
	
	short stolenPlayer = StolenPlayer.NONE;
	switch (stolenFrom)
	{
	case Position.NORTH:
	    stolenPlayer = StolenPlayer.LEFT;
	    break;
	case Position.WEST:
	    stolenPlayer = StolenPlayer.ACROSS;
	    break;
	case Position.SOUTH:
	    stolenPlayer = StolenPlayer.RIGHT;
	    break;
	}

	if ((actionMask & Action.LATE_KAN) == Action.LATE_KAN)
	{
	    Tile[] tiles = new Tile[3];
	    tiles[0] = tile;
	    tiles[1] = tile;
	    tiles[2] = tile;
	    OpenMeld meld = new OpenMeld(tiles, MeldType.LATE_KAN, stolenPlayer, tile);
	    lateKanMeld.notify(meld);
	    lateKanPanel.setVisible(true);
	}
	else lateKanPanel.setVisible(false);

	if ((actionMask & Action.CLOSED_KAN) == Action.CLOSED_KAN)
	{
	    Tile[] tiles = new Tile[3];
	    tiles[0] = tile;
	    tiles[1] = tile;
	    tiles[2] = tile;
	    OpenMeld meld = new OpenMeld(tiles, MeldType.CLOSED_KAN, stolenPlayer, tile);
	    closedKanMeld.notify(meld);
	    closedKanPanel.setVisible(true);
	}
	else closedKanPanel.setVisible(false);	
	
	tsumoPanel.setVisible((actionMask & Action.TSUMO) == Action.TSUMO);
	nothingPanel.setVisible((actionMask & Action.NONE) == Action.NONE);

	answer = Action.NONE;
	this.setResizable(true);
	this.pack();
	Dimension thisDimension = this.getSize();
	this.setLocation((int)(1024 - thisDimension.getWidth())/2, (int)(768 - thisDimension.getHeight())/2);
	this.setResizable(false);
	this.show();
	return (answer);
    }

    // main text
    private JLabel messageLabel = new JLabel();
    private JLabel tileLabel = new JLabel();
    
    // late kan
    private JButton lateKanButton = new JButton("Pon >> Kan");
    private EastMeldPanel lateKanMeld = new EastMeldPanel();
    private JPanel lateKanPanel = new JPanel();

    // closed kan
    private JButton closedKanButton = new JButton("Kan");
    private EastMeldPanel closedKanMeld = new EastMeldPanel();
    private JPanel closedKanPanel = new JPanel();
    
    // tsumo
    private JButton tsumoButton = new JButton("Tsumo");
    private JLabel tsumoLabel = new JLabel();
    private JPanel tsumoPanel = new JPanel();

    // nothing
    private JButton nothingButton = new JButton("Nada");
    private JLabel nothingLabel = new JLabel();
    private JPanel nothingPanel = new JPanel();

    // message result
    int answer;
}
