package mahjong;

import java.util.*;

public abstract class Intelligence
{
    public Intelligence (Player player)
    {
	this.player = player;	
	hand = player.getHand();
	closedTiles = hand.getClosedTiles();
    }
    
    public abstract Tile discard(int drawType);    
    public abstract int wantTile(Tile theTile, short stolenPlayer);
    
    protected boolean makeReach()
    {
	boolean isTenpai;
	int i;
	Tile aTile;
	
	if (!hand.isClosed())
	    return false;
	for (i = 1; i < 10; i++)
	{
	    aTile = new Tile(TileType.PINZU, (short) i);
	    hand.addClosedTile(aTile);
	    isTenpai = player.makeAnalyse(Action.RON, false);
	    hand.removeTile(aTile);
	    if (isTenpai)
		return true;
	}
	for (i = 1; i < 10; i++)
	{
	    aTile = new Tile(TileType.SOUZU, (short) i);
	    hand.addClosedTile(aTile);
	    isTenpai = player.makeAnalyse(Action.RON, false);
	    hand.removeTile(aTile);
	    if (isTenpai)
		return true;
	}
	for (i = 1; i < 10; i++)
	{
	    aTile = new Tile(TileType.WANZU, (short) i);
	    hand.addClosedTile(aTile);
	    isTenpai = player.makeAnalyse(Action.RON, false);
	    hand.removeTile(aTile);
	    if (isTenpai)
		return true;
	}
	for (i = 1; i < 5; i++)
	{
	    aTile = new Tile(TileType.KAZEHAI, (short) i);
	    hand.addClosedTile(aTile);
	    isTenpai = player.makeAnalyse(Action.RON, false);
	    hand.removeTile(aTile);
	    if (isTenpai)
		return true;
	}
	for (i = 1; i < 4; i++)
	{
	    aTile = new Tile(TileType.SANGENPAI, (short) i);
	    hand.addClosedTile(aTile);
	    isTenpai = player.makeAnalyse(Action.RON, false);
	    hand.removeTile(aTile);
	    if (isTenpai)
		return true;
	}
	return false;
    }

	protected Player player;
	protected Hand hand;
	protected ArrayList closedTiles;
	
}
