package mahjong;

import java.util.*;

public class Result
{
    private Result()   { }

    public static Result getInstance()
    {
	return finalResult;
    }

    public void insereBatida(Batida batida)
    {
	batidas.add(batida);
    }

    public ArrayList getBatidas()
    {
	return (batidas);
    }

    public void printResult()
    {
	Batida umaBatida;
	for (int i = 0; i < batidas.size(); i++)
	{
	    umaBatida = (Batida) batidas.get(i);
	    System.out.println("Batida: " + umaBatida.getName());
	    System.out.println("Han:    " + umaBatida.getHan());
	}
    }

    public boolean search(String name)
    {
	for (int i = 0; i < batidas.size(); i++)
	    if (((Batida) batidas.get(i)).getName().equals(name))
		return true;
	return false;
    }

    public boolean getStatus()
    {
	if (batidas.size() > 0)
	    return true;
	else 
	    return false;
    }

    public void setWinner(short winner)
    {
	this.winner = winner;
    }

    public short getWinner()
    {
	return winner;
    }

    public void reset()
    {
	batidas = new ArrayList();
	status = false;
	winner = -1;
    }

    public int getTotalHan()
    {
	int result = 0;

	for (int i = 0; i < batidas.size(); i++)
	    result += ((Batida)batidas.get(i)).getHan();

	return (result);
	    
    }
    
    private ArrayList batidas = new ArrayList();
    private boolean status = false;
    private short winner = -1;

    static private Result finalResult = new Result();
}










