package mahjong;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class SouthPlayerPanel extends PlayerPanel
{
   public SouthPlayerPanel()
   {
       super();
       defaultRotation = 90;

       // Assembling the closed tiles panel
       closedTilesPanel.setLayout(new BoxLayout(closedTilesPanel, BoxLayout.Y_AXIS));
       closedTilesPanel.setAlignmentX(Component.RIGHT_ALIGNMENT);
       for (int i = closedTiles.length - 1; i >= 0; i--)
       {
          closedTiles[i] = new TaggedLabel(i);
          closedTilesPanel.add(closedTiles[i]);
       }

       // Assembling the melds panel
       meldsPanel.setLayout(new BoxLayout(meldsPanel, BoxLayout.Y_AXIS));
       meldsPanel.setAlignmentX(Component.RIGHT_ALIGNMENT);
       for (int i = melds.length - 1; i >= 0; i--)
       {
          melds[i] = new SouthMeldPanel();
          meldsPanel.add(Box.createRigidArea(new Dimension(5, 5)));
          meldsPanel.add(melds[i]);
       }

       // Assembling the reach panel
       reachPanel.setLayout(new BoxLayout(reachPanel, BoxLayout.Y_AXIS));
       reachPanel.add(Box.createVerticalGlue());
       reachPanel.add(reachLabel);
       reachPanel.add(Box.createVerticalGlue());
       reachPanel.add(diceLabel);

       // Assembling the discarded tiles panel
       discardedTilesPanel.setLayout(new GridLayout(10, 2, 5, 5));
       for (int i = 0; i < discardedTiles.length; i++)
          discardedTiles[i] = new JLabel();

       for (int i = 9; i >= 0; i--)
       {        
          discardedTilesPanel.add(discardedTiles[i]);
          discardedTilesPanel.add(discardedTiles[i + 10]);
       }

       JPanel auxPanel1 = new JPanel();
       auxPanel1.setLayout(new BoxLayout(auxPanel1, BoxLayout.Y_AXIS));
       auxPanel1.setBackground(new Color(0.20f, 0.70f, 0.20f));
       auxPanel1.add(meldsPanel);
       auxPanel1.add(Box.createRigidArea(new Dimension(0, 10)));
       auxPanel1.add(closedTilesPanel);

       JPanel auxPanel2 = new JPanel();
       auxPanel2.setLayout(new BoxLayout(auxPanel2, BoxLayout.Y_AXIS));
       auxPanel2.setBackground(new Color(0.20f, 0.70f, 0.20f));
       auxPanel2.add(Box.createVerticalGlue());
       auxPanel2.add(discardedTilesPanel);
       auxPanel2.add(Box.createVerticalGlue());

       makeInitHand();
       this.setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
       this.add(auxPanel2);
       this.add(Box.createRigidArea(new Dimension(5, 5)));
       this.add(reachPanel);
       this.add(Box.createRigidArea(new Dimension(5, 5)));
       this.add(auxPanel1);
   }
}

class SouthMeldPanel extends MeldPanel
{
   SouthMeldPanel()
   {
       super();
       defaultRotation = 90;

       this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
       for (int i = coupleTilePanel.length - 1; i >= 0; i--)
       {
           //coupleTilePanel[i] = new JPanel();
           coupleTilePanel[i].setAlignmentX(Component.RIGHT_ALIGNMENT);
           coupleTilePanel[i].setLayout(new BoxLayout(coupleTilePanel[i], BoxLayout.X_AXIS));
           upperTiles[i] = new JLabel();
           lowerTiles[i] = new JLabel();
           coupleTilePanel[i].add(upperTiles[i]);
           coupleTilePanel[i].add(lowerTiles[i]);
           this.add(coupleTilePanel[i]);
       }
   }
}
