package mahjong;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class WestPlayerPanel extends PlayerPanel
{
    public WestPlayerPanel()
    {
	super();
        defaultRotation = 180;

        JPanel auxPanel1 = new JPanel();
        auxPanel1.setLayout(new BoxLayout(auxPanel1, BoxLayout.X_AXIS));
	auxPanel1.setBackground(new Color(0.20f, 0.70f, 0.20f));

	//assembling the discarded tiles panel
        JPanel auxPanel2 = new JPanel();
        auxPanel2.setLayout(new BoxLayout(auxPanel2, BoxLayout.X_AXIS));
	auxPanel2.setBackground(new Color(0.20f, 0.70f, 0.20f));
        discardedTilesPanel.setLayout(new GridLayout(2, 9, 0, 5));
        for (int i = discardedTiles.length - 1; i >= 0; i--)
	{
	    discardedTiles[i] = new JLabel();
	    discardedTilesPanel.add(discardedTiles[i]);
	}
        auxPanel2.add(Box.createHorizontalGlue());
        auxPanel2.add(discardedTilesPanel);
        auxPanel2.add(Box.createHorizontalGlue());
        auxPanel1.add(auxPanel2);

	//assembling the reach panel
	reachPanel.setLayout(new BoxLayout(reachPanel, BoxLayout.X_AXIS));
        reachPanel.add(Box.createHorizontalGlue());
        reachPanel.add(reachLabel);
        reachPanel.add(Box.createHorizontalGlue());
	reachPanel.add(diceLabel);

	// assembling melds panel
        for (int i = 3; i >= 0; i--)
	{
            melds[i] = new WestMeldPanel();
	    meldsPanel.add(melds[i]);
	}
        JPanel auxPanel3 = new JPanel();
	auxPanel3.setBackground(new Color(0.20f, 0.70f, 0.20f));
        auxPanel3.add(meldsPanel);

	// assembling the closed tiles panel
        closedTilesPanel.setLayout(new BoxLayout(closedTilesPanel, BoxLayout.X_AXIS));
        for (int i = closedTiles.length -1; i >= 0; i--)
	{
	    closedTiles[i] = new TaggedLabel(i);
	    closedTilesPanel.add(closedTiles[i]);
	}
        auxPanel3.add(closedTilesPanel);

	makeInitHand();
        this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        this.add(auxPanel3);
        this.add(reachPanel);
        this.add(auxPanel1);
    }
}

class WestMeldPanel extends MeldPanel
{
    WestMeldPanel()
    {
	super();
        defaultRotation = 180;

	// Assembling panel
        this.setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
        for (int i = 3; i >= 0; i--)
	{
	    upperTiles[i] = new JLabel();
	    lowerTiles[i] = new JLabel();
	    //coupleTilePanel[i] = new JPanel();
            coupleTilePanel[i].setAlignmentY(Component.TOP_ALIGNMENT);
            coupleTilePanel[i].setLayout(new BoxLayout(coupleTilePanel[i], BoxLayout.Y_AXIS));
            coupleTilePanel[i].add(lowerTiles[i]);
            coupleTilePanel[i].add(upperTiles[i]);
	    this.add(coupleTilePanel[i]);
	}
    }
}









